//
// Created by philipp on 08.05.18.
//

#ifndef CAR_LOGGINGSTREAM_H
#define CAR_LOGGINGSTREAM_H

#include <nodelet/nodelet.h>
#include <ros/ros.h>
#include <string>
#include "car/logStringMsg.h"

namespace car
{

class MessageOStream
{
public:
    using Manipulator = MessageOStream & (*)(MessageOStream &);

    explicit MessageOStream(ros::NodeHandle & nh)
        : logStringPublisher(nh.advertise<logStringMsg>("logString", 1))
    {}

    template<typename T>
    friend MessageOStream & operator<<(MessageOStream & stream, const T & value)
    {
        stream.oss << value;
        return stream;
    }

    friend MessageOStream & operator<<(MessageOStream & stream, Manipulator manipulator)
    { return manipulator(stream); }

    static MessageOStream & flush(MessageOStream & stream)
    {
        logStringMsg msg;
        msg.logMsg = stream.oss.str();
        stream.logStringPublisher.publish(msg);
        stream.oss = std::ostringstream{};
        return stream;
    }

private:
    ros::Publisher logStringPublisher;
    std::ostringstream oss;
};

}

#endif //CAR_LOGGINGSTREAM_H
